<cfcomponent>
<!--- *
	  * METHOD: authenticateUser(login, password);
	  * Used for authentication challange
	  *
	  *** --->

	<cffunction name="authenticateUser" access="remote" returntype="any">
		<cfargument name="login" type="string" required="yes">
		<cfargument name="password" type="string" required="no" >
		<!--- Challange the Login / Password sent from the Flash Player --->
		<CFQUERY NAME="q_checkUser" Datasource="myFlashComDb.mdb">
			SELECT UserID, fname, lname From Users 
				WHERE login='#arguments.login#' 
				AND Password = '#arguments.password#';
		</CFQUERY>
		<CFSCRIPT>
			/* Setup inital variables */
			ret_Obj = structNew();
			ret_Obj.isLoginOK= false;
			ret_Obj.userName = q_checkUser.fname & " " & q_checkUser.lname;	
			if (q_checkUser.recordCount neq 0) {
				/* call the cf function, "setTicket" passing it the UserID */
				ticketObj = this.setTicket(q_checkUser.UserID);
				// Copy the ticket object into the local ret_obj scope
				ret_Obj.ticket = ticketObj.ticket;
				ret_Obj.expiry = ticketObj.expiry;
				ret_Obj.isLoginOK= true;
			}

			return ret_Obj;
		</CFSCRIPT>
	</cffunction>

<!--- *
	  * METHOD: setTicket(userID);
	  * Used to generate a new ticket and store it in the DB
	  *
	  *** --->

	<cffunction name="setTicket" access="remote" returntype="any">
		<cfargument name="userID" type="any" required="yes">	
		<CFSCRIPT>
			  // create a new Ticket Object that will store the ticket info
			  ticket_Obj = structNew();
			  // set the ticket using CreateUUID and HASH					
			  ticket_Obj.ticket = Hash(CreateUUID());
			  // set tht initial expiry Date
			  ticket_Obj.expiry = CreateODBCDateTime(DateAdd("yyyy",10,now()));
		</CFSCRIPT>
		<!--- place the ticket into the database.  Note, this could also be an application object --->
		<CFQUERY NAME="q_setTicket" Datasource="myFlashComDb.mdb">
			INSERT INTO Users_ticket (ticket, UserID, expiry) 
			VALUES('#ticket_Obj.ticket#', #arguments.userID#, #ticket_Obj.expiry#);
		</CFQUERY>

		<CFRETURN ticket_Obj>
    </cffunction>

<!--- *
	  * METHOD: updateTicket(ticket_hash, newExpiry);
	  * Used to update the expiry value of a ticket
	  *
	  *** --->

	<cffunction name="findTicket" access="remote" returntype="any">
		<cfargument name="ticket_hash" type="any" required="yes">	
		<CFQUERY NAME="q_getUser" Datasource="myFlashComDb.mdb">
			SELECT Users.fname, Users.lname
			FROM Users INNER JOIN Users_Ticket 
				ON Users.UserID = Users_Ticket.UserID
			WHERE 
			        users_Ticket.ticket = '#arguments.ticket_hash#'
				and users_Ticket.expiry > now();
		</CFQUERY>

		<CFSCRIPT>
			return_obj = structNew();
			return_obj.userName = q_getUser.fname & " " & q_getUser.lname;
			if (q_getUser.recordCount neq 0) return_obj.isTicketOK = true;
			 else return_obj.isTicketOK = false;
			 
			/* Return the Object to the Caller */ 
			return return_obj;
		</CFSCRIPT>

	</cffunction>

<!--- *
	  * METHOD: updateTicket(ticket_hash, newExpiry);
	  * Used to update the expiry value of a ticket
	  *
	  *** --->
	<cffunction name="updateTicket" access="remote" returntype="boolean">
		<cfargument name="ticket_hash" type="any" required="yes">
		<cfargument name="new_expiry" type="numeric" required="false" default="1">		
			
			<CFQUERY NAME="q_getUser" Datasource="myFlashComDb.mdb">
			UPDATE users_Ticket 
				set Expiry = #CreateODBCDateTime(DateAdd("h",new_expiry,now()))#
				where ticket = '#ticket_hash#'
			</CFQUERY>
		
		<CFReturn true>
	</cffunction>


</cfcomponent>